import java.util.Arrays;



public class Palabra implements Comparable <Palabra>{
	
	private String  cadena;
	private String signatura;
	
	public Palabra(String p){
		cadena = p.toLowerCase();
		char[]s = cadena.toCharArray();
		Arrays.sort(s);
		signatura = new String(s);
	}
	
	public boolean esAnagrama(Palabra s){
		return signatura.equals(s.signatura);
	}
	
	public boolean equals (Object o){
		if (o instanceof Palabra){
			Palabra other = (Palabra)o;
			return (cadena.equalsIgnoreCase(other.cadena));
		}else{
			return false;
		}
	}
	
	public int hashCode(){
		return cadena.hashCode();
	}
	
	public int compareTo(Palabra s) {
		return cadena.compareToIgnoreCase(s.cadena);
	}
	
	public String toString(){
		return cadena+" ";
	}
	
	public String getPalabra(){
		return cadena;
	}
	
	public String getSignatura(){
		return signatura;
	}
}
