import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;


public class Cerradura {
	public static final int MAX_MARCAS_POR_ANCLAJE = 4;
	private List <Set<Integer>> anclajes;
	private int numAnclajes;
	
	public Cerradura(int tam)throws LyCException{
		if(tam > MAX_MARCAS_POR_ANCLAJE){
			throw new LyCException("Numero de anclajes demasiado grande");
		}
		numAnclajes = tam;
		anclajes=new ArrayList<Set<Integer>>();
		for (int i = 0; i < numAnclajes; i++) {
			anclajes.add(new HashSet<Integer>());
		}
	}
	
	public void agregarMarca(int anclaje, int marca)throws LyCException{
		if (anclaje < 0 || anclaje > anclajes.size()) {
			new LyCException("Numero de anclaje incorrecto");
		} else {
			Set<Integer> a = anclajes.get(anclaje);
			a.add(marca);
		}
	}
	private static boolean encajaDienteAnclaje(int altura, Set <Integer> anclaje){
		int x = 10 - altura;
		if (anclaje.contains(x)) {
			return true;
		}
		return false;
	}
	public boolean abrir(Llave llave){
		boolean abre = (llave.numDientes() == anclajes.size());
		if (abre) {
			for (int i = 0; i < anclajes.size(); i++) {
				if (encajaDienteAnclaje(llave.obtenerAltura(i),
						anclajes.get(i))==false&&abre==true) {
					abre=true;
				}else{
					abre=false;
				}
			}
			return true;
		}
		return false;
		}
	public String toString(){
		return anclajes.toString();
	}
}
